// load any tabs on the page
var seocart_version = 'seo-cart';
var imageItemsOriginalLength; // for photoswipe to determine index for attribute images
$(function () {
    /* tabs and image viewer (lightbox) */
    if (typeof (window.$.fn.tabs) != "undefined") {
        $('#seocart_Tabs').tabs().show();
    }
    if (typeof (window.$.fn.accordion) != "undefined") {
        $('.seocart_Accordion').accordion({
            heightStyle: 'content'
        });
    }
    if (typeof (window.$.fn.lightBox) != "undefined") {
        $('div.seocart_Product a[rel^=lightbox]').lightBox({useOverlayInIE: false, fixedNavigation: true, imageRoot: "/cirkuit/includes/"});
    }

    /* attribute swatches */
    $('div.seocart_AttributeSwatchContainer a.attributeSwatch').click(function (event) {
        event.preventDefault();
        var $this = $(this);
        var selectedSwatchAttributeName = $this.data('attribute-name');
        var selectedSwatchOption = $this.data('attribute-option');
        var $attributeSelect = $('select[name="' + selectedSwatchAttributeName + '"]');

        $('a.attributeSwatch', $(this).closest('.seocart_AttributeSwatchContainer')).removeClass('selected'); // unselect all
        $(this).addClass('selected'); // selected current

        $attributeSelect.val(selectedSwatchOption); // update drop down menu
        $attributeSelect.trigger('change');
    });
    $('div.seocart_ProductAttributeContainer select').change(function () {
        var $this = $(this);
        var $selected_option = $('option:selected', $this);
        var attribute_image_src = $selected_option.data('attribute-image-src');
        if (attribute_image_src && typeof (attribute_image_src) != 'undefined') { // change main image
            var $main_image = $('#mainImage');
            var $main_image_anchor = $main_image.closest('a'); // for lightbox
            var attribute_image_width = $selected_option.data('attribute-image-width');
            var attribute_image_height = $selected_option.data('attribute-image-height');
            var attribute_zoom_image_src = $selected_option.data('attribute-zoom-image-src');
            var attribute_zoom_image_width = $selected_option.data('attribute-zoom-image-width');
            var attribute_zoom_image_height = $selected_option.data('attribute-zoom-image-height');
            if ($main_image.attr('src') != attribute_image_src) {
                
                if (typeof(imageItems) != "undefined") { // photoswipe attribute image support, just push attribute image and set index    
                    if (!imageItemsOriginalLength) {
                        imageItemsOriginalLength = imageItems.length;
                    }
                    var zoomSrc = attribute_zoom_image_src;
                    var zoomWidth = attribute_zoom_image_width;
                    var zoomHeight = attribute_zoom_image_height;
                    var imageItem = {
                        src:zoomSrc,
                        w:zoomWidth,
                        h:zoomHeight
                    };
                    imageItems[imageItemsOriginalLength] = imageItem;
                    $main_image.data('index',imageItemsOriginalLength);
                }
                
                $main_image.fadeOut(100, function () {
                    $main_image.attr({
                        'src': attribute_image_src,
                        'width': attribute_image_width,
                        'height': attribute_image_height
                    });
                    $main_image.data('zoomimagesrc', attribute_zoom_image_src)
                    $main_image.data('zoomimagewidth', attribute_zoom_image_width)
                    $main_image.data('zoomimageheight', attribute_zoom_image_height)
                    if ($main_image_anchor.length > 0) {
                        $main_image_anchor.attr('href', attribute_zoom_image_src);
                    }
                    $main_image.fadeIn();
                });
            }
        }
        // check to update swatch
        var $attributeSwatchContainer = $this.next('div.seocart_AttributeSwatchContainer');
        var $attributeSwatch = $('a.attributeSwatch[data-attribute-option="' + $this.val() + '"]', $attributeSwatchContainer);
        if ($attributeSwatch.length > 0) {
            $('a.attributeSwatch', $attributeSwatchContainer).removeClass('selected'); // unselect all
            $attributeSwatch.addClass('selected'); // selected current
        }
    });

    /* instant order notifications */
    $(document).on('click', 'div.seocart_InventoryInstockNotification a', function () {
        var $this = $(this);
        var $seocart_InventoryInstockNotification = $this.closest('div.seocart_InventoryInstockNotification');
        var $seocart_InStockNotificationEmailContainer = $('div.seocart_InStockNotificationEmailContainer', $seocart_InventoryInstockNotification);
        $seocart_InStockNotificationEmailContainer.toggle();
    });
    $(document).on('click', 'div.seocart_InventoryInstockNotification input[name="seocart_instock_notification_submit"]', function () {
        var $this = $(this);
        var $seocart_InStockNotificationEmailContainer = $this.closest('div.seocart_InStockNotificationEmailContainer');
        var $seocart_InStockNotificationEmailResults = $('div.seocart_InStockNotificationEmailResults', $seocart_InStockNotificationEmailContainer);
        var $seocart_InStockNotificationAttrib = $('input[type="hidden"][name="seocart_instock_notification_attrib"]');
        var $loadingAnimation = $('<div class="seocart_InStockNotification_Loading"><img src="/cirkuit/includes/images/loadingAnimations/circular.gif" border="0" alt=""></div>');
        var productId = new Number($('input[type="hidden"][name="seocart_ProductId"]').val());
        var notificationAttrib = "";
        if ($seocart_InStockNotificationAttrib.length > 0) {
            notificationAttrib = $seocart_InStockNotificationAttrib.val();
        }
        var email = $('input[name="seocart_instock_notification_email"]', $seocart_InStockNotificationEmailContainer).val();
        $seocart_InStockNotificationEmailResults.html($loadingAnimation);
        $.ajax({
            url: '/cirkuit/' + seocart_version + '/ajax/front-end?action=addInventoryInstockNotification&productId=' + encodeURIComponent(productId) + '&notificationAttrib=' + encodeURIComponent(notificationAttrib) + '&email=' + encodeURIComponent(email),
            dataType: 'json',
            success: function (data) {
                $loadingAnimation.remove();
                $seocart_InStockNotificationEmailResults.html(data.message);
            }
        });
    });

    /* PRODUCT QA */
    var initProductQA = function ($productQA) { //closure

        //ajax functionality
        var ajax = {

            //centralize common ajax vars
            url: "/cirkuit/" + seocart_version + "/ajax/front-end",
            _responseError: function () {
                alert("Error receiving response from server, browser data may be out of sync. Please refresh the current page.");
            },
            _commonError: function () {
                alert("Error sending request, browser data may be out of sync. Please refresh the current page.");
            },
            _commonSuccess: function (result, callback) {
                if (!result) {
                    ajax._responseError();
                    return;
                }

                //callback
                if (typeof (callback) == "function") {
                    callback.call(this, result);
                }
            },

            question: {
                //create a new product question
                //product_id - int
                //questionTxt - string
                //callback signature: function(result){...}
                add: function (product_id, questionTxt, callback) {
                    $.ajax({
                        type: 'POST',
                        url: ajax.url,
                        data: {
                            action: "newProductQA",
                            product_id: product_id,
                            question: questionTxt
                        },
                        dataType: 'json',
                        success: function (result) {
                            ajax._commonSuccess.call(this, result, callback);
                        },
                        error: ajax._commonError
                    });
                }
            },
            answer: {
                //create a new product answer
                //product_qa_id - int
                //answerTxt - string
                //callback signature: function(result){...}
                add: function (product_qa_id, answerTxt, callback) {
                    $.ajax({
                        type: 'POST',
                        url: ajax.url,
                        data: {
                            action: "newProductQAAnswer",
                            product_qa_id: product_qa_id,
                            answer: answerTxt
                        },
                        dataType: 'json',
                        success: function (result) {
                            ajax._commonSuccess.call(this, result, callback);
                        },
                        error: ajax._commonError
                    });
                },
                //marks a product answer as helpful or unhelpful
                //answer_id - int
                //helpful - bool - yes or no if the answer is helpful
                //callback signature: function(result){...}
                helpful: function (answer_id, helpful, callback) {
                    $.ajax({
                        type: 'POST',
                        url: ajax.url,
                        data: {
                            action: "modifyProductQAAnswerHelpful",
                            answer_id: answer_id,
                            helpful: helpful
                        },
                        dataType: 'json',
                        success: function (result) {
                            ajax._commonSuccess.call(this, result, callback);
                        },
                        error: ajax._commonError
                    });
                }
            },
            notify_list: {
                //add a new email to notify
                //product_qa_id - int
                //callback signature: function(result){...}
                add: function (product_qa_id, callback) {
                    $.ajax({
                        type: 'POST',
                        url: ajax.url,
                        data: {
                            action: "addProductQANotifyEmail",
                            product_qa_id: product_qa_id
                        },
                        dataType: 'json',
                        success: function (result) {
                            ajax._commonSuccess.call(this, result, callback);
                        },
                        error: ajax._commonError
                    });
                }
            }
        };

        //helper function to show a short msg next to the element specified at $location
        var show_message = function (msg, $location, cssClass) {
            var locationOffset = $location.offset();
            var $qa_msg = $('#qa_msg').stop(true, true);
            if ($qa_msg.length == 0) {
                $qa_msg = $('<div id="qa_msg"></div>')
                        .hide()
                        .appendTo('body');
            }

            $qa_msg.text(msg)
                    .addClass(cssClass)
                    .css({
                        'position': 'absolute',
                        'z-index': 9999,
                        'top': (locationOffset.top + $location.outerHeight()) + 'px',
                        'left': (locationOffset.left) + 'px',
                        'display': 'none'
                    })
                    .fadeIn(350)
                    .delay(4000)
                    .fadeOut(350, function () {
                        $(this).remove();
                    })
        };

        //ATTACH CLICK EVENTS

        //new question
        $productQA.find('.qa-ask-btn').click(function () {
            var $this = $(this);
            var $inputWrap = $this.next('.qa-input-ask-wrap');

            $inputWrap.slideDown(250);
            $this.slideUp(250);
        });
        $productQA.find('.qa-input-ask-submit-btn').click(function () {
            var $this = $(this);
            var product_id = $this.closest('.product-qa').attr('data-productid');
            if (product_id) {
                //collect input
                var $inputWrap = $this.closest('.qa-input-ask-wrap');
                var $textarea = $inputWrap.find('textarea,qa-input-ask-txt');
                var inputTxt = $textarea.val();

                //error checking
                if (!inputTxt) {
                    show_message("Enter a question.", $this, 'qa_msg_fail');
                    return false;
                }
                if (inputTxt.length > 500) {
                    show_message("Question must be less than 500 characters (currently " + inputTxt.length + ").", $this, 'qa_msg_fail');
                    return false;
                }

                //ajax submit
                ajax.question.add(product_id, inputTxt, function (result) {
                    //ajax callback
                    if (result.success) { //server said success. show msg
                        $textarea.val('');

                        var $askBtn = $inputWrap.prev('.qa-ask-btn');
                        $inputWrap.slideUp(250);
                        $askBtn.slideDown(250, function () {
                            show_message(result.message || 'Thanks!', $askBtn, 'qa_msg_success');
                        });
                    } else { //server said error. show msg
                        show_message(result.message || 'Error', $this, 'qa_msg_fail');
                    }
                });
            }
        });

        //new answer
        $productQA.find('.qa-answer-btn').click(function () {
            var $this = $(this);
            var $inputWrap = $this.next('.qa-input-answer-wrap');

            $inputWrap.slideDown(250);
            $this.slideUp(250);
        });
        $productQA.find('.qa-input-answer-submit-btn').click(function () {
            var $this = $(this);
            var qa_question_id = $(this).closest('.qa-question').attr('data-productqaid');
            if (qa_question_id) {
                //collect input
                var $inputWrap = $this.closest('.qa-input-answer-wrap');
                var $textarea = $inputWrap.find('textarea,qa-input-answer-txt');
                var inputTxt = $textarea.val();

                //error checking
                if (!inputTxt) {
                    show_message("Enter text to submit.", $this, 'qa_msg_fail');
                    return false;
                }

                //ajax submit
                ajax.answer.add(qa_question_id, inputTxt, function (result) {
                    //ajax callback
                    if (result.success) { //server said success. show msg
                        $textarea.val('');

                        var $answerBtn = $inputWrap.prev('.qa-answer-btn');
                        $inputWrap.slideUp(250);
                        $answerBtn.slideDown(250, function () {
                            show_message(result.message || 'Thanks!', $answerBtn, 'qa_msg_success');
                        });
                    } else { //server said error. show msg
                        show_message(result.message || 'Error', $this, 'qa_msg_fail');
                    }
                });
            }
        });

        //increase helpful count
        $productQA.find('.qa-answer-helpful-yes a').click(function () {
            var $this = $(this);
            var answer_id = $(this).closest('.qa-answer').attr('data-answerid');
            if (answer_id) {
                //ajax submit
                ajax.answer.helpful(answer_id, 1, function (result) {
                    //ajax callback
                    if (result.success) {
                        var $curCount = $this.find('span');
                        var curCount = parseInt($curCount.text(), 10);
                        $curCount.text(curCount + 1);
                        show_message(result.message || 'Thanks!', $this, 'qa_msg_success');
                    } else { //server said error. show msg
                        show_message(result.message || 'Error', $this, 'qa_msg_fail');
                    }
                });
            }
            return false;
        });

        //increase unhelpful count
        $productQA.find('.qa-answer-helpful-no a').click(function () {
            var $this = $(this);
            var answer_id = $(this).closest('.qa-answer').attr('data-answerid');
            if (answer_id) {
                //ajax submit
                ajax.answer.helpful(answer_id, 0, function (result) {
                    //ajax callback
                    if (result.success) {
                        var $curCount = $this.find('span');
                        var curCount = parseInt($curCount.text(), 10);
                        $curCount.text(curCount + 1);
                        show_message(result.message || 'Thanks!', $this, 'qa_msg_success');
                    } else { //server said error. show msg
                        show_message(result.message || 'Error', $this, 'qa_msg_fail');
                    }
                });
            }
            return false;
        });

        //add new notify email address
        $productQA.find('.qa-notify-add a').click(function () {
            var $this = $(this);
            var qa_question_id = $(this).closest('.qa-question').attr('data-productqaid');
            if (qa_question_id) {
                //ajax submit
                ajax.notify_list.add(qa_question_id, function (result) {
                    //ajax callback
                    if (result.success) { //server said success. show msg
                        show_message(result.message || 'Thanks!', $this, 'qa_msg_success');
                    } else { //server said error. show msg
                        show_message(result.message || 'Error', $this, 'qa_msg_fail');
                    }
                });
            }
            return false;
        });

    }; //closure

    //init product qa if we're on a page with a product-qa section
    var $productQA = $('.product-qa');
    if ($productQA.length > 0) {

        //expand and collapse answers
        $productQA.find('.qa-expand').click(function () {

            //hide any old ajax-messages that may be on the screen. they're absolutely positioned, so this next animation throws it out of place
            $('#qa_msg').stop(true, true).remove();

            var $this = $(this);
            var $thisQuestion = $this.closest('.qa-question');
            var $answerWrap = $thisQuestion.find('.qa-question-details-wrap');

            if ($answerWrap.is(':hidden')) {
                $this.text('-');
                $answerWrap.stop(true, true).slideDown(200);
            } else {
                $this.text('+');
                $answerWrap.stop(true, true).slideUp(200);
            }
            return false;
        });

        //if customer is logged in, init product qa interaction 
        if ($productQA.is('.loggedIn')) {
            initProductQA($productQA);
        }
    }
    /* END PRODUCT QA */

});